#ifndef CoreEvents_h
#define CoreEvents_h

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include "verbose.h"

//taken from: https://amperemail.sharepoint.com/:x:/r/sites/Furiosa/_layouts/15/Doc.aspx?sourcedoc=%7B1E05A983-187A-4551-966E-873EE8EF5B35%7D&file=Furiosa%20PMU%20Events.xlsx&action=default&mobileredirect=true&DefaultItemOpen=1
////mnemonics ending in "_WTH" didn't have mnemonics in the spreadsheet so I'm guessing

struct PMU_EVENT
{
  char name[56];
  uint64_t number;
};

struct PMU_EVENT pmu_events[270] = {
	{"SW_INCR",0x0000},{"L1I_CACHE_REFILL",0x0001},{"L1I_TLB_REFILL",0x0002},{"L1D_CACHE_REFILL",0x0003},{"L1D_CACHE",0x0004},{"L1D_TLB_REFILL",0x0005},{"LD_RETIRED",0x0006},{"ST_RETIRED",0x0007}, {"INST_RETIRED",0x0008},{"EXC_TAKEN",0x0009},
	
	{"EXC_RETURN",0x000A},{"CID_WRITE_RETIRED",0x000B},{"PC_WRITE_RETIRED",0x000C},{"BR_IMMED_RETIRED",0x000D},{"BR_RETURN_RETIRED",0x000E},{"BR_MIS_PRED",0x0010},{"CPU_CYCLES",0x0011},{"BR_PRED",0x0012},{"MEM_ACCESS",0x0013},{"L1I_CACHE",0x0014},

	{"L2D_CACHE",0x0016},{"L2D_CACHE_REFILL",0x0017},{"L2D_CACHE_WB",0x0018},{"BUS_ACCESS",0x0019},{"_MEMORY_ERROR",0x001A},{"INST_SPEC",0x001B},{"TTBR_WRITE_RETIRED",0x001C},{"BUS_CYCLES",0x001D},{"CHAIN",0x001E},{"BR_RETIRED",0x0021},					
	
	{"BR_MIS_PRED_RETIRED",0x0022},{"STALL_FRONTEND",0x0023},{"STALL_BACKEND",0x0024},{"L1D_TLB",0x0025},{"L1I_TLB",0x0026},{"L2D_TLB_REFILL",0x002D},{"L2I_TLB_REFILL",0x002E},{"L2D_TLB",0x002F},{"L2I_TLB",0x0030},{"DTLB_WALK",0x0034},

	{"ITLB_WALK",0x0035},{"L1D_CACHE_LMISS_RD",0x0039},{"OP_RETIRED",0x003A},{"OP_SPEC",0x003B},{"STALL",0x003C},{"STALL_SLOT_BACKEND",0x003D},{"STALL_SLOT_FRONTEND",0x003E},{"STALL_SLOT",0x003F},{"L1D_CACHE_RD",0x0040},{"L1D_CACHE_WR",0x0041},				
	
	{"L1D_CACHE_REFILL_RD",0x0042},{"L1D_CACHE_REFILL_WR",0x0043},{"L1D_CACHE_INVAL",0x0048},{"L1D_TLB_REFILL_RD",0x004C},{"L1D_TLB_REFILL_WR",0x004D},{"L1D_TLB_RD",0x004E},{"L1D_TLB_WR",0x004F},{"L2D_CACHE_RD",0x0050},{"L2D_CACHE_WR",0x0051},{"L2D_CACHE_REFILL_RD",0x0052},

	{"L2D_CACHE_REFILL_WR",0x0053},{"L2D_CACHE_WB_VICTIM",0x0056},{"L2D_CACHE_WB_CLEAN",0x0057},{"L2D_CACHE_INVAL",0x0058},{"L2D_TLB_REFILL_RD",0x005C},{"L2D_TLB_REFILL_WR",0x005D},{"L2D_TLB_RD",0x005E},{"L2D_TLB_WR",0x005F},{"BUS_ACCESS_RD",0x0060},{"BUS_ACCESS_WR",0x0061},				
	
	{"MEM_ACCESS_RD",0x0066},{"MEM_ACCESS_WR",0x0067},{"LDREX_SPEC",0x006C},{"STREX_PASS_SPEC",0x006D},{"STREX_FAIL_SPEC",0x006E},{"STREX_SPEC",0x006F},{"LD_SPEC",0x0070},{"ST_SPEC",0x0071},{"LDST_SPEC",0x0072},{"DP_SPEC",0x0073},

	{"ASE_SPEC",0x0074},{"VFP_SPEC",0x0075},{"PC_WRITE_SPEC",0x0076},{"CRYPTO_SPEC",0x0077},{"BR_IMMED_SPEC",0x0078},{"BR_RETURN_SPEC",0x0079},{"BR_INDIRECT_SPEC",0x007A},{"ISB_SPEC",0x007C},{"DSB_SPEC",0x007D},{"DMB_SPEC",0x007E},					
	
	{"CSDB_SPEC",0x007F},{"EXC_UNDEF",0x0081},{"EXC_SVC",0x0082},{"EXC_PABORT",0x0083},{"EXC_DABORT",0x0084},{"XC_IRQ",0x0086},{"EXC_FIQ",0x0087},{"EXC_SMC",0x0088},{"EXC_HVC",0x008A},{"EXC_TRAP_PABORT",0x008B},

	{"EXC_TRAP_DABORT",0x008C},{"EXC_TRAP_OTHER",0x008D},{"EXC_TRAP_IRQ",0x008E},{"EXC_TRAP_FIQ",0x008F},{"RC_LD_SPEC",0x0090},{"RC_ST_SPEC",0x0091},{"L2_PREFETCH_REFILL",0x010A},{"L2_PREFETCH_UPGRADE",0x010B},{"BPU_HIT_BTB",0x0110},					
	
	{"BPU_CONDITIONAL_BRANCH_HIT_BTB",0x0111},{"BPU_HIT_INDIRECT_PREDICTOR",0x0112},{"BPU_HIT_RSB",0x0113},{"BPU_UNCONDITIONAL_BRANCH_MISS_BTB",0x0114},{"BPU_BRANCH_NO_HIT",0x0115},{"BPU_HIT_BTB_AND_MISPREDICT",0x0116},{"BPU_CONDITIONAL_BRANCH_HIT_BTB_AND_MISPREDICT",0x0117},{"BPU_INDIRECT_BRANCH_HIT_BTB_AND_MISPREDICT",0x0118},	{"BPU_HIT_RSB_AND_MISPREDICT",0x0119},{"BPU_MISS_RSB_AND_MISPREDICT",0x011A},

	{"BPU_NO_PREDICTION_MISPREDICT",0x011B},{"BPU_BTB_UPDATE",0x011C},{"BPU_RSB_FULL_STALL",0x011D},{"ICF_INST_SPEC_DECODE",0x011F},{"GPC_FLUSH",0x0120},{"GPC_FLUSH_MEM_FAULT",0x0121},{"MSC_ETM_EXTOUT0",0x0141},{"MSC_ETM_EXTOUT1",0x0142},{"MSC_ETM_EXTOUT2",0x0143},				
	
	{"MSC_ETM_EXTOUT3",0x0144},{"L2C_SNOOP",0x0156},{"L2C_DAT_CRD_STALL",0x0169},{"L2C_RSP_CRD_STALL",0x016A},{"L2C_REQ_CRD_STALL",0x016B},{"SAMPLE_POP",0x4000},{"SAMPLE_FEED",0x4001},{"SAMPLE_FILTRATE",0x4002},{"SAMPLE_COLLISION",0x4003},{"CNT_CYCLES",0x4004},

	{"STALL_BACKEND_MEM",0x4005},{"L1I_CACHE_LMISS",0x4006},{"L2D_CACHE_LMISS_RD",0x4009},{"LDST_ALIGN_LAT",0x4020},{"LD_ALIGN_LAT",0x4021},{"ST_ALIGN_LAT",0x4022},{"MEM_ACCESS_CHECKED",0x4024},{"MEM_ACCESS_CHECKED_RD",0x4025},{"MEM_ACCESS_CHECKED_WR",0x4026},{"BR_SKIP_RETIRED",0x8107},				
	
	{"BR_IMMED_TAKEN_RETIRED",0x8108},{"BR_INDNR_TAKEN_RETIRED",0x810C},{"BR_IMMED_PRED_RETIRED",0x8110},{"BR_IMMED_MIS_PRED_RETIRED",0x8111},{"BR_IND_PRED_RETIRED",0x8112},{"BR_IND_MIS_PRED_RETIRED",0x8113},{"BR_RETURN_PRED_RETIRED",0x8114},{"BR_RETURN_MIS_PRED_RETIRED",0x8115},{"BR_INDNR_PRED_RETIRED",0x8116},{"BR_INDNR_MIS_PRED_RETIRED",0x8117},

	{"BR_TAKEN_PRED_RETIRED",0x8118},{"BR_TAKEN_MIS_PRED_RETIRED",0x8119},{"BR_SKIP_PRED_RETIRED",0x811A},{"BR_SKIP_MIS_PRED_RETIRED",0x811B},{"BR_PRED_RETIRED",0x811C},{"BR_IND_RETIRED",0x811D},{"ICF_EARLY_MIS_PRED",0xD100},{"ICF_FEQ_FULL",0xD101},{"ICF_INST_FIFO_FULL",0xD102},{"L1I_TLB_MISS",0xD103},				
	
	{"ICF_STALL",0xD104},{"ICF_PC_FIFO_FULL",0xD105},{"IDR_STALL_BOB_ID",0xD200},{"IDR_STALL_LOB_ID",0xD201},{"IDR_STALL_SOB_ID",0xD202},{"IDR_STALL_IXU_SCHED",0xD203},{"IDR_STALL_FSU_SCHED",0xD204},{"IDR_STALL_ROB_ID",0xD205},{"IDR_STALL_FLUSH",0xD206},{"IDR_STALL_WFI",0xD207},

	{"IDR_STALL_SWOB_TIMEOUT",0xD208},{"IDR_STALL_SWOB_RAW",0xD209},{"IDR_STALL_SWOB_FULL",0xD20A},{"STALL_FRONTEND_CACHE",0xD20B},{"STALL_FRONTEND_TLB",0xD20C},{"STALL_BACKEND_CACHE",0xD20D},{"STALL_BACKEND_TLB",0xD20E},{"STALL_BACKEND_RESOURCE",0xD20F},{"IXU_NUM_UOPS_ISSUED",0xD300},{"IXU_ISSUE_CANCEL",0xD301},				
	
	{"IXU_LOAD_CANCEL",0xD302},{"IXU_SLOW_CANCEL",0xD303},{"IXU_IXA_ISSUED",0xD304},{"IXU_IXA_PAR0_ISSUED",0xD305},{"IXU_IXA_PAR1_ISSUED",0xD306},{"IXU_IXB_ISSUED",0xD307},{"IXU_IXB_PAR0_ISSUED",0xD308},{"IXU_IXB_PAR1_ISSUED",0xD309},{"IXU_IXC_ISSUED",0xD30A},{"IXU_IXC_PAR0_ISSUED",0xD30B},

	{"IXU_IXC_PAR1_ISSUED",0xD30C},{"IXU_IXD_ISSUED",0xD30D},{"IXU_IXD_PAR0_ISSUED",0xD30E},{"IXU_IXD_PAR1_ISSUED",0xD30F},{"FSU_ISSUED",0xD400},{"FSU_FSX_ISSUED",0xD401},{"FSU_FSY_ISSUED",0xD402},{"FSU_FSZ_ISSUED",0xD403},{"FSU_CANCEL",0xD404},{"FSU_DIV_SQRT_STALL",0xD405},				
	
	{"GPC_SWOB_DRAIN",0xD500},{"BREAKPOINT_MATCH",0xD501},{"GPC_CPM_TRIGGER",0xD502},{"L1D_TLB_MISS",0xD600},{"OFB_FULL",0xD601},{"LD_FROM_ST_FWD",0xD605},{"L1_PREFETCH_LD_GEN",0xD606},{"L1_PREFETCH_LD_FILL",0xD607},{"L1_PREFETCH_L2_REQ",0xD608},{"L1_PREFETCH_DIST_RST",0xD609},{"L1_PREFETCH_DIST_INC",0xD60A},

	{"L1_PREFETCH_ENTRY_TRAINED",0xD60B},{"LSU_ST_RETIRE_STALL",0xD60C},{"WATCHPOINT_MATCH",0xD60D},{"L2C_INST_REFILL",0xD701},{"L2C_DATA_REFILL",0xD702},{"L2_PREFETCH_REQ",0xD703},{"MMU_D_OTB_ALLOC",0xD800},{"MMU_D_TRANS_CACHE_HIT_S1L2_WALK",0xD801},{"MMU_D_TRANS_CACHE_HIT_S1L1_WALK",0xD802},{"MMU_D_TRANS_CACHE_HIT_S1L0_WALK",0xD803},		
	
	{"MMU_D_TRANS_CACHE_HIT_S2L2_WALK",0xD804},{"MMU_D_TRANS_CACHE_HIT_S2L1_WALK",0xD805},{"MMU_D_TRANS_CACHE_HIT_S2L0_WALK",0xD806},{"MMU_D_S1_WALK_CACHE_LOOKUP",0xD807},{"MMU_D_S1_WALK_CACHE_REFILL",0xD808},{"MMU_D_S2_WALK_CACHE_LOOKUP",0xD809},{"MMU_D_S2_WALK_CACHE_REFILL",0xD80A},{"MMU_D_S1_WALK_FAULT",0xD80B},{"MMU_D_S2_WALK_FAULT",0xD80C},{"MMU_D_WALK_STEPS",0xD80D},

	{"MMU_I_OTB_ALLOC",0xD900},{"MMU_I_TRANS_CACHE_HIT_S1L2_WALK",0xD901},{"MMU_I_TRANS_CACHE_HIT_S1L1_WALK",0xD902},	{"MMU_I_TRANS_CACHE_HIT_S1L0_WALK",0xD903},{"MMU_I_TRANS_CACHE_HIT_S2L2_WALK",0xD904},{"MMU_I_TRANS_CACHE_HIT_S2L1_WALK",0xD905},{"MMU_I_TRANS_CACHE_HIT_S2L0_WALK",0xD906},{"MMU_I_S1_WALK_CACHE_LOOKUP",0xD907},{"MMU_I_S1_WALK_CACHE_REFILL",0xD908},{"MMU_I_S2_WALK_CACHE_LOOKUP",0xD909},			
	
	{"MMU_I_S2_WALK_CACHE_REFILL",0xD90A},{"MMU_I_S1_WALK_FAULT",0xD90B},{"MMU_I_S2_WALK_FAULT",0xD90C},{"MMU_I_WALK_STEPS",0xD90D},{"DUMMY_EVENT_1",0xFFFE},{"DUMMY_EVENT_2",0xFFFF},{"DUMMY_EVENT_1",0xFFFE},{"DUMMY_EVENT_1",0xFFFE},{"DUMMY_EVENT_1",0xFFFE},{"DUMMY_EVENT_1",0xFFFE},{"DUMMY_EVENT_1",0xFFFE}
};

char* pmu_event_name_from_number(uint64_t number)
{
  for(uint64_t i=0;i<260;i++)
  {
    if(pmu_events[i].number == number)
      return(pmu_events[i].name);
  }
  verbose(4,"PMU NUMBER NOT FOUND.  Looking for 0x%04X.  Returning DUMMY_EVENT_1\n", number);
  return(pmu_events[259].name);
}

uint64_t pmu_event_number_from_name(char* name)
{
  for(uint64_t i=0;i<260;i++)
  {
    if(strcmp(pmu_events[i].name,name) == 0)
      return(pmu_events[i].number);
  }
  verbose(4,"PMU EVENT NAME NOT FOUND.  Looking for %s. Returning 259\n");
}

void list_events()
{
  printf("Number, Event Name\n");
  printf("------  ----------\n");
  for(uint64_t i=0;i<257;i++)
  {
    printf("0x%04X, %s\n",pmu_events[i].number,pmu_events[i].name);
  }
}
#endif

